define([
	'intern/dojo/node!leadfoot/lib/util'
], function (util) {
	function remoteRequire(moduleIds, callback, timeout) {
		return function () {
			var session = this.session;
			var originalTimeout;

			return session.getExecuteAsyncTimeout().then(function () {
				if (!isNaN(timeout)) {
					originalTimeout = arguments[0];
				}
				else {
					timeout = arguments[0];
				}

				return session.setExecuteAsyncTimeout(timeout).then(function () {
					return session.executeAsync(function (moduleIds, callback, done) {
						callback = new Function(callback);
						require(moduleIds, function () {
							var result = callback.apply(null, arguments);

							if (result && typeof result.then === 'function') {
								result.then(done);
							}
							else {
								done(result);
							}
						});
					}, [ moduleIds, util.toExecuteString(callback) ]);
				}).finally(function (result) {
					function finish() {
						if (result instanceof Error) {
							throw result;
						}
						else {
							return result;
						}
					}

					if (!isNaN(originalTimeout)) {
						return session.setExecuteAsyncTimeout(originalTimeout).then(finish);
					}
					else {
						return finish();
					}
				});
			});
		};
	};

	return remoteRequire;
});
