/* jshint node:true */
var path = require('path');
var fs = require('fs');

function escapeRegExp(str) {
	return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
}

function rewrite(args) {
	/* jshint -W044 */
	// check if splicable is already in the body text
	var re = new RegExp(args.splicable.map(function (line) {
		return '\s*' + escapeRegExp(line);
	}).join('\n'));

	if (re.test(args.haystack)) {
		return args.haystack;
	}

	var lines = args.haystack.split('\n');

	var otherwiseLineIndex = 0;
	lines.forEach(function (line, i) {
		if (line.indexOf(args.needle) !== -1) {
			otherwiseLineIndex = i;
		}
	});

	var whitespace = lines[otherwiseLineIndex].match(/^(\s*)/);
	var spaceStr = '';

	if (whitespace) {
		spaceStr = whitespace[1];
	}

	lines.splice(otherwiseLineIndex, 0, args.splicable.map(function (line) {
		return spaceStr + line;
	}).join('\n'));

	return lines.join('\n');
}

function rewriteFile(args) {
	args.path = args.path || process.cwd();
	var fullPath = path.join(args.path, args.file);

	args.haystack = fs.readFileSync(fullPath, 'utf8');
	var body = rewrite(args);

	fs.writeFileSync(fullPath, body);
}

module.exports = {
	rewrite: rewrite,
	rewriteFile: rewriteFile
};
